#ifndef A_LEVELITEM_H
#define A_LEVELITEM_H

#include <QGraphicsItem>
#include <QGraphicsRectItem>
#include <QGraphicsSceneMouseEvent>

class HistogramView;

class LevelItem : public QGraphicsItem
{
public:
	enum HandleRole {LeftHandle, RightHandle};
	LevelItem(QGraphicsRectItem*, int, HistogramView*);
	QRectF boundingRect() const override;

protected:
	void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget*) override;
	void mousePressEvent(QGraphicsSceneMouseEvent*) override;
	void mouseReleaseEvent(QGraphicsSceneMouseEvent*) override;
	QVariant itemChange(GraphicsItemChange, const QVariant &) override;

private:
	QGraphicsRectItem * m_item;
	HistogramView * view;
	HandleRole m_role;
	bool m_pressed{};
};

#endif

