#include "helpwidget.h"

HelpWidget::HelpWidget()
{
	setupUi(this);
	set_text();
#ifdef __APPLE__
	minimaze_sc = new QShortcut(QKeySequence("Ctrl+M"), this, SLOT(showMinimized()));
	minimaze_sc->setAutoRepeat(false);
	fullsceen_sc = new QShortcut(QKeySequence("Ctrl+Meta+F"),this,SLOT(showFullScreen()));
	fullsceen_sc->setAutoRepeat(false);
	normal_sc = new QShortcut(QKeySequence("Esc"),this,SLOT(showNormal()));
	normal_sc->setAutoRepeat(false);
#endif
}

// clang-format off
void HelpWidget::set_text()
{
	const QString s(
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\"><html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">p, li { white-space: pre-wrap; }</style></head><body style=\" font-family:'Cantarell'; font-size:13pt; font-weight:400; font-style:normal;\"><p align=\"center\" style=\" margin-top:16px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:x-large; font-weight:600;\">De&#x2011;identify</span></p><p align=\"center\" style=\" margin-top:16px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:large; font-weight:600;\">Application Level Confidentiality Profile Attributes 2021b</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Select input and output folders. Input folder can contain tree of sub-folders, multiple patients and studies. The integrity of data sets will be maintained, applicable UIDs, IDs, PNs will be mapped consistently to randomly generated values, applicable date and time attributes will be shifted by a single randomly chosen offset. Currently DICOMDIR files will be skipped and not appear in a output folder.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Pixel data will be not modified. It is the responsibility of the operator to ensure that pixel data does not contain recognizable features and burned&#x2011;in annotations. Note: in <span style=\" font-style:italic;\">Aliza Medical Imaging &amp; DICOM Viewer </span>program is possible to modify pixel data (using e.g. selection and mask to cut off parts of the image, draw tool, etc.) and re&#x2011;export data in DICOM format (optionally set study, series, frame of reference and patient attributes) or non-DICOM format.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> For details see <a href=\"https://www.aliza-dicom-viewer.com/manual/dicom-specification/application-level-confidentiality-profile-attributes\"><span style=\" text-decoration: underline; color:#0000ff;\">Application Level Confidentiality Profile Attributes </span></a>. Please note that the standard does not necessarily guarantee confidentiality. National and local regulations, which may vary, might require that additional attributes be de-identified, though the Profiles and Options have been designed to be sufficient to satisfy known regulations without compromising the usefulness of the de-identified instances for their intended purpose. It is the responsibility of the operator to ensure that all identifying information is removed. It is recommended to review de-identified data sets in <span style=\" font-style:italic;\">Metadata Viewer</span>. Note: in <span style=\" font-style:italic;\">Aliza Medical Imaging &amp; DICOM Viewer </span>program is possible to edit attributes for individual files or series in <span style=\" font-style:italic;\">Metadata Viewer</span>.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; text-decoration: underline; color:#0000ff;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Optionally, replace <span style=\" font-style:italic;\">Patient&nbsp;Name</span> and/or <span style=\" font-style:italic;\">Patient&nbsp;ID</span> with selected value. It is possible only if input folder contains single patient (<span style=\" font-style:italic;\">Patient ID</span> will be checked for all files to ensure). Format is <span style=\" text-decoration: underline;\">Surname&nbsp;Name</span> or DICOM VR&nbsp;PN, e.g. <span style=\" text-decoration: underline;\">Surname^Name^^^</span>. Character set must be consistent with <span style=\" font-style:italic;\">Specific Character Set </span>attribute. Supported character sets are: ISO_IR&nbsp;6, ISO_IR&nbsp;13, ISO_IR&nbsp;100,  ISO_IR&nbsp;101, ISO_IR&nbsp;109, ISO_IR&nbsp;110, ISO_IR&nbsp;126, ISO_IR&nbsp;127, ISO_IR&nbsp;138, ISO_IR&nbsp;144, ISO_IR&nbsp;148, ISO_IR&nbsp;166, ISO_IR&nbsp;192, GB18030, GBK. Custom character sets may work. Code extensions are not supported.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Generate random names</span> custom option is checked, names (VR&nbsp;PN) will be consistently mapped to randomly chosen common north American names, such as J.&nbsp;W.&nbsp;Smith or C.&nbsp;I.&nbsp;Gonzales. If not checked, the names will look like J.&nbsp;W.&nbsp;S. or C.&nbsp;I.&nbsp;G, for example. </p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Check <span style=\" font-style:italic;\">Confirm clean pixel data</span> to add <span style=\" font-style:italic;\">Clean Pixel Data Option  </span>to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; text-decoration: underline; color:#0000ff;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Check <span style=\" font-style:italic;\">Confirm no recognizable features  </span>to add <span style=\" font-style:italic;\">Clean Recognizable Visual Features Option</span> to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Retains UIDs</span> option is checked, applicable UIDs will be preserved and <span style=\" font-style:italic;\">Retain UIDs Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence</span>, otherwise they will be consistently mapped with randomly generated values.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Retain patient characteristics</span> option is checked, applicable attributes, such as weight, size, will be preserved and <span style=\" font-style:italic;\">Retain Patient Characteristics Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence. </span>For example, it is required to calculate SUV from PET series.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Retain dates and time </span>option is checked, applicable date and time attributes will be preserved and <span style=\" font-style:italic;\">Retain Longitudinal Temporal Information Full Dates Option </span>will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence</span>, otherwise applicable date and time attributes will be consistently modified and <span style=\" font-style:italic;\">Retain Longitudinal Temporal Information Modified Dates Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence</span>. Identifying attributes, e.g. birth date, will be never preserved. It is important to note that if studies of a patient are de-identified sequentially, for example every month, it may be important to retain dates and time to maintain longitudinal integrity, if possible.</p><p align=\"justify\" style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Retain device identity </span>option is checked, applicable attributes, such as device ID, will be preserved and <span style=\" font-style:italic;\">Retain Device Identity Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Retain institution identity</span> option is checked, applicable attributes, such as station name, institution address, will be preserved and <span style=\" font-style:italic;\">Retain Institution Identity Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Remove private attributes </span>option is <span style=\" font-weight:600;\">not</span> checked, private attributes are assumed to be safe and <span style=\" font-style:italic;\">Retain Safe Private Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p align=\"justify\" style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Remove graphics </span>option is <span style=\" font-weight:600;\">not</span> checked, graphics objects are assumed to be safe and <span style=\" font-style:italic;\">Clean Graphics Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Remove structured content</span> option is <span style=\" font-weight:600;\">not</span> checked, structured content related to SR IODs, is assumed to be safe and <span style=\" font-style:italic;\">Clean Structured Content Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> If <span style=\" font-style:italic;\">Remove descriptors option</span> is <span style=\" font-weight:600;\">not</span> checked, descriptors, such as study and series description, RT ROI names, RT plan names, etc., are assumed to be safe and <span style=\" font-style:italic;\">Clean Descriptors Option</span> will be added to <span style=\" font-style:italic;\">De&#x2011;identification Method Code Sequence.</span></p><p align=\"justify\" style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-style:italic;\"><br /></p><p align=\"justify\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> Check <span style=\" font-style:italic;\">Rename files</span> to rename output files and folders. Required if files are named by some identifying string, such as name or instance ID, unfortunately it is common wrong practice. Size of file and folder names will be <span style=\" font-style:italic;\">8 chars</span> to satisfy DICOM standard requirement. In highly unlikely case a size of file name may be more as <span style=\" font-style:italic;\">8 chars</span>, to avoid numeric overflow, because files are named by incrementing number.</p><p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p></body></html>");
	textBrowser->setHtml(s);
}

